=== share/hedgewars/Data/Missions/CMakeLists.txt ===
add_subdirectory(Training)
add_subdirectory(Campaign)
