=== share/hedgewars/Data/Names/CMakeLists.txt ===
file(GLOB txtnames *.txt)
file(GLOB cfgnames *.cfg)

install(FILES
	types.ini
	${txtnames}
	${cfgnames}
	DESTINATION ${SHAREPATH}Data/Names)
