=== share/hedgewars/Data/Scripts/CMakeLists.txt ===
file(GLOB luafiles *.lua)

install(FILES
	${luafiles}
	DESTINATION ${SHAREPATH}Data/Scripts)

add_subdirectory(Multiplayer)
