=== debian/changelog ===
hedgewars (0.9.15-4) unstable; urgency=low

  * Exclude buggy icnsutils from B-D.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 07 Jul 2011 17:23:34 +0400

hedgewars (0.9.15-3) unstable; urgency=low

  * Fixed hicolor icons path. 

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 06 Jul 2011 11:25:45 +0400

hedgewars (0.9.15-2) unstable; urgency=low

  * Fixed depends (FTBFS, closes: #629778), closed fake bug (closes: #631152).
  * Bump Standards-Version to 3.9.2.
  * Install hicolor icons, closes: #621792,
    thanks to Kees Cook <kees@debian.org>.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 05 Jul 2011 17:35:56 +0400

hedgewars (0.9.15-1) unstable; urgency=low

  * New upstream version.
   + Ability to create, save and load hand drawn maps
   + New maps: Capture the Flag (Blizzard) Map
   + New themes: Christmas
   + Snowflakes on Christmas/Snow themes accumulates on the ground
   + New game modifiers: No wind, More wind
   + New missions: Dangerous ducklings, Diver, Spooky tree, Teamwork
   + New weapons: Mudball, Drill strike
   + Many more Lua hooks
   + Readytimer
   + Ability to edit seed
   + Ability to select gameplay scripts
   + New gameplay scripts: Capture the Flag, No jumping, Random weapon
   + New Lua unified translation framework
   + Code refactoring
   + Max teams upped to 8
   + Cosmetic enhancements to Napalm strike
   + Selecting a game scheme selects the corresponding weapon set
   + Dust when drills dig
   + New hats: beaver, porkey, sheep
   + Add density property to Gears
   + Reworked management of schemes and weapon sets
   + Will ask before deleting teams, schemes and weapon sets
   + Explosions detach rope from land
   + Allow hog speech when not your turn

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 28 Dec 2010 23:29:54 +0300
